blob: 8a442e5f112bb19e9e497251b4761cbbaf5d7c46 [file] [log] [blame]
Brian Silvermand1c19fb2016-07-07 00:10:57 -07001#!/bin/bash
2
3# The bazel script calls this instead of the bazel-real binary which is
4# installed next to it. This script downloads a specific version of Bazel and
5# then calls that.
6
7# Alternatively, if the environment variable BAZEL_OVERRIDE is set, that will be
8# run directly (after printing a message). That is intended for testing only.
9
10# This script operates based on the assumption that any directory of the correct
11# name is a fully extracted, valid Bazel installation. It is careful to avoid
12# putting an invalid directory at that name at any point.
13
14set -e
15set -u
16set -o pipefail
17
18if [[ -n "${BAZEL_OVERRIDE+x}" ]]; then
19 tput setaf 1 >&2
20 echo -n "Actually calling " >&2
21 tput setaf 3 >&2
22 echo "${BAZEL_OVERRIDE}" >&2
23 tput sgr0 >&2
24 exec "${BAZEL_OVERRIDE}" "$@"
25fi
26
Austin Schuhbe8c9b12017-11-25 15:53:12 -080027readonly VERSION="201711232100+e0fe5d9"
Brian Silvermand1c19fb2016-07-07 00:10:57 -070028
29readonly DOWNLOAD_DIR="$(dirname "${BASH_SOURCE[0]}")/../bazel-downloads"
30# Directory to unpack bazel into. This must change whenever bazel changes.
31readonly VERSION_DIR="${DOWNLOAD_DIR}/${VERSION}-v1"
32readonly VERSION_BAZEL="${VERSION_DIR}/usr/bin/bazel"
33
34# Creating might fail if another invocation is racing us.
35if [[ ! -d "${DOWNLOAD_DIR}" ]]; then
36 mkdir "${DOWNLOAD_DIR}" || true
37fi
38if [[ ! -d "${DOWNLOAD_DIR}" ]]; then
39 echo "Failed to create ${DOWNLOAD_DIR}" >&2
40 exit 1
41fi
42
Austin Schuh9d92e6b2017-10-17 01:19:38 -070043readonly INSTALLER_NAME="bazel_${VERSION}-linux-x86_64.deb"
Brian Silvermand1c19fb2016-07-07 00:10:57 -070044readonly DOWNLOAD_URL="http://frc971.org/Build-Dependencies/${INSTALLER_NAME}"
45
46if [[ ! -d "${VERSION_DIR}" ]]; then
47 echo "Downloading Bazel version ${VERSION} from ${DOWNLOAD_URL}..." >&2
48
49 # A temporary directory which is definitely on the same filesystem as our final
50 # destination, which is important so we can atomically move it.
51 # If this move is non-atomic, then a concurrent Bazel command (like the verifier
52 # uses several of) could use a half-copied Bazel installation.
53 TEMP_DIR="$(mktemp --directory --tmpdir="${DOWNLOAD_DIR}")"
54 readonly TEMP_DIR
55
56 ( cd "${TEMP_DIR}"
57 wget "${DOWNLOAD_URL}" -O "${INSTALLER_NAME}" --no-verbose --show-progress
58 echo "Unpacking Bazel version ${VERSION}..." >&2
59 dpkg-deb -x "${INSTALLER_NAME}" extracted
60 )
61
62 touch "${TEMP_DIR}/extracted/usr/bin/bazel.bazelrc"
63
64 # Careful: somebody else might have already done it. If they manage to make
65 # the move between our check and our move, then we'll end up with a random
66 # extracted directory which won't do anybody any harm. If somebody else does
67 # that first, then our move will fail.
68 if [[ ! -d "${VERSION_DIR}" ]]; then
69 mv "${TEMP_DIR}/extracted" "${VERSION_DIR}" || true
70 fi
71 if [[ ! -d "${VERSION_DIR}" ]]; then
72 echo "Failed to create ${VERSION_DIR}" >&2
73 exit 1
74 fi
75 rm -rf "${TEMP_DIR}"
76 echo "Done downloading Bazel version ${VERSION}"
77fi
78
Austin Schuh77cc2c32016-12-28 22:01:38 -080079ENVIRONMENT_VARIABLES=()
80ENVIRONMENT_VARIABLES+=(HOSTNAME="${HOSTNAME}")
81ENVIRONMENT_VARIABLES+=(SHELL="${SHELL}")
82ENVIRONMENT_VARIABLES+=(USER="${USER}")
83ENVIRONMENT_VARIABLES+=(PATH="${PATH}")
Austin Schuh77cc2c32016-12-28 22:01:38 -080084ENVIRONMENT_VARIABLES+=(HOME="${HOME}")
85ENVIRONMENT_VARIABLES+=(LOGNAME="${LOGNAME}")
86ENVIRONMENT_VARIABLES+=(TERM="${TERM}")
87
Brianfcf3ee72017-03-05 13:30:54 -080088if [[ ! -z "${LANG+x}" ]]; then
89 ENVIRONMENT_VARIABLES+=(LANG="${LANG}")
90fi
91
Austin Schuh77cc2c32016-12-28 22:01:38 -080092if [[ ! -z "${DISPLAY+x}" ]]; then
93 ENVIRONMENT_VARIABLES+=(DISPLAY="${DISPLAY}")
94fi
95
Brian Silvermand1c19fb2016-07-07 00:10:57 -070096if [[ -x "${VERSION_BAZEL}-real" ]]; then
97 exec -a "${VERSION_BAZEL}" env -i \
Austin Schuh77cc2c32016-12-28 22:01:38 -080098 "${ENVIRONMENT_VARIABLES[@]}" \
Brian Silvermand1c19fb2016-07-07 00:10:57 -070099 "${VERSION_BAZEL}-real" "$@"
100fi
101if [[ -x "${VERSION_BAZEL}" ]]; then
102 exec env -i \
Austin Schuh77cc2c32016-12-28 22:01:38 -0800103 "${ENVIRONMENT_VARIABLES[@]}" \
Brian Silvermand1c19fb2016-07-07 00:10:57 -0700104 "${VERSION_BAZEL}" "$@"
105fi
106
107echo "Can't find the real bazel!" >&2
108exit 1